=== debian/changelog ===
lz4 (0.0~r122-2) unstable; urgency=medium

  * Install pkgconfig file into liblz4-dev. (Closes: #761906)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 17 Sep 2014 08:55:01 +0900

lz4 (0.0~r122-1) unstable; urgency=high

  * Snapshot, taken from the trunk (r122).
  * Fix test on s390x. (Closes: #757581)
    Add patches/0001-Add-support-s390x-architecture.patch.
  * Remove patches.
    - add-support-kfreebsd.patch, add-support-hurd.patch and Add-LDFLAGS.patch
      were applied to upstream.
    - Makefile of upstream was updated.
      Remove 0001-Remove-test-32-from-test-target.patch.
  * Update patches/0001-Disable-valgrind.patch.
  * Update debian/rules.
    - Re-enable test on s390x.
  * Update symbols file.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 17 Sep 2014 01:57:08 +0900

lz4 (0.0~r119-2) unstable; urgency=medium

  * Disable test on s390x and sparc. (Closes: #755170)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 29 Jul 2014 01:43:36 +0900

lz4 (0.0~r119-1) unstable; urgency=medium

  * Snapshot, taken from the trunk (r119) (Closes: #751256).
  * The r119 fixed CVE-2014-4715, and r118 fixed CVE-2014-4611.
  * Disable valgrind test.
    Add patches/0001-Disable-valgrind.patch.
  * Disable test with -m32 option.
    Add patches/0001-Remove-test-32-from-test-target.patch.
  * Update liblz4-1.symbols.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 15 Jul 2014 10:25:02 +0900

lz4 (0.0~r117-1) unstable; urgency=medium

  * Snapshot, taken from the trunk (r117).
  * Remove patches/add-ldflags.patch and patches/fix-install.patch.
  * Update patches/add-support-kfreebsd.patch.
  * Add patches/add-support-hurd.patch (Closes: #749901).
  * Add patches/Remove-32bit-test-program-from-target.patch.
  * Add patches/Add-LDFLAGS.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 09 Jun 2014 14:57:21 +0900
