=== debian/changelog ===
lz4 (0.0~r130-1) unstable; urgency=medium

  * Snapshot, taken from the trunk (r130).

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 01 Jun 2015 09:35:45 +0900

lz4 (0.0~r127-1) experimental; urgency=low

  * Snapshot, taken from the trunk (r127).
  * Update debian/docs.
    Add lz4_block_format.txt and LZ4_Frame_Format.html.
  * Update liblz4-1.symbols.
  * Bump Standards-Version to 3.9.6.
  * Update copyright.
    Add more infomation of copyright.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 07 Mar 2015 17:21:34 +0900
