=== debian/control ===
Source: lz4
Priority: extra
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9.0.0)
Standards-Version: 3.9.6
Section: utils
Homepage: http://code.google.com/p/lz4/
Vcs-Git: git://anonscm.debian.org/collab-maint/lz4.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/lz4.git;a=summary

Package: liblz4-dev
Section: libdevel
Architecture: any
Depends: liblz4-1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Fast LZ compression algorithm library - development files
 LZ4 is a very fast lossless compression algorithm, providing compression speed
 at 400 MB/s per core, scalable with multi-cores CPU. It also features an
 extremely fast decoder, with speed in multiple GB/s per core, typically
 reaching RAM speed limits on multi-core systems.
 .
 This package contains files that are needed to build applications.

Package: liblz4-1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Fast LZ compression algorithm library - runtime
 LZ4 is a very fast lossless compression algorithm, providing compression speed
 at 400 MB/s per core, scalable with multi-cores CPU. It also features an
 extremely fast decoder, with speed in multiple GB/s per core, typically
 reaching RAM speed limits on multi-core systems.
 .
 This package includes the shared library.

Package: liblz4-1-dbg
Section: debug
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, liblz4-1 (= ${binary:Version})
Replaces: liblz4-0.0-dbg (<= 0.0~r113-1)
Conflicts: liblz4-0.0-dbg (<= 0.0~r113-1)
Description: Fast LZ compression algorithm library - Debugging Symbols
 LZ4 is a very fast lossless compression algorithm, providing compression speed
 at 400 MB/s per core, scalable with multi-cores CPU. It also features an
 extremely fast decoder, with speed in multiple GB/s per core, typically
 reaching RAM speed limits on multi-core systems.
 .
 This package contains the debugging symbols.

Package: liblz4-tool
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, liblz4-1 (= ${binary:Version})
Multi-Arch: foreign
Description: Fast LZ compression algorithm library - tool
 LZ4 is a very fast lossless compression algorithm, providing compression speed
 at 400 MB/s per core, scalable with multi-cores CPU. It also features an
 extremely fast decoder, with speed in multiple GB/s per core, typically
 reaching RAM speed limits on multi-core systems.
 .
 This package contains files that is tool using liblz4.
