=== debian/rules ===
--- 
+++ 
@@ -8,10 +8,12 @@
 LDFLAGS:= $(shell dpkg-buildflags --get LDFLAGS)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_ARCH_BITS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)
+PREFIX:= /usr
 
 export CFLAGS
 export CPPFLAGS
 export LDFLAGS
+export PREFIX
 
 disable_test=0
 # BTS: #755170
